window.Novillus = window.Novillus || {};
let loader = window.Novillus.Loader = {};

let html = `
  <svg class="novillus-loader__svg" width="120px" height="120px" viewBox="0 0 120 120" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
      <defs>
        <circle id="right" cx="75" cy="45" r="42"></circle>
        <circle id="bottom" cx="60" cy="80" r="42"></circle>
        <circle id="center" cx="60" cy="60" r="42"></circle>
        <circle id="left" cx="45" cy="45" r="42"></circle>

      </defs>

      <g id="logo-1" stroke="none" stroke-width="0" fill="none" fill-rule="evenodd">
        <g id="primary">
            <g id="primary-color">
                <mask id="mask-2">
                    <use xlink:href="#left" fill="white"></use>
                    <use class='subtracted' xlink:href="#bottom" fill="black"></use>
                </mask>
                <use class="mask" opacity="0" xlink:href="#left"></use>
                <use class="main" xlink:href="#center" mask="url(#mask-2)"></use>
            </g>
        </g>

        <g id="mid">
            <g id="mid-color">
                <mask id="mask-3">
                    <use xlink:href="#right" fill="white"></use>
                    <use class='subtracted' xlink:href="#left" fill="black"></use>
                </mask>
                <use class="mask" opacity="0" xlink:href="#right"></use>
                <use class="main" xlink:href="#center" fill="#9D9EA2" mask="url(#mask-3)"></use>
            </g>
        </g>

        <g id="dark">
            <g id="dark-color">
                <mask id="mask-4">
                    <use xlink:href="#bottom" fill="white"></use>
                    <use class='subtracted' xlink:href="#right" fill="black"></use>
                </mask>
                <use class="mask" opacity="0" xlink:href="#bottom"></use>
                <use class="main" xlink:href="#center" fill="#000" mask="url(#mask-4)"></use>
            </g>
        </g>
    </g>
  </svg>
`;

let elem = function() {
  let div = document.getElementById('novillus-loader');
  if (div) {
    return div;
  }
  div = document.createElement('div');
  div.innerHTML = html;
  div.id = 'novillus-loader';
  div.className = 'novillus-loader novillus-loader-full-screen hidden';
  document.body.appendChild(div);
  return div;
};

loader.show = function() {
  let div = elem();
  div.className = 'novillus-loader-full-screen';
};

loader.hide = function() {
  let div = elem();
  div.className = 'novillus-loader-full-screen hidden';
}

Object.defineProperty(loader, 'html', {
  get() {
    return `<div class="novillus-loader novillus-loader-full-screen hidden">${html}</div>`;
  }
})

document.addEventListener("DOMContentLoaded", elem);


export default window.Novillus.Loader;
